# Copyright 2021, TATA Consultancy Services. All rights reserved.

import tensorflow 
from tensorflow.keras.layers import Input, Dense, Conv2D, Flatten, MaxPooling2D,Activation,BatchNormalization,Dropout,concatenate
from tensorflow.keras.models import Model
from CNNetR import CNNetR

def CNNet(nrw, ncl, num_classes):

    #-------- Varsha Edit-----------#
    if nrw == 12:
        mp1a = 3; mp1b = 3
        mp2a = 2; mp2b = 2
        mp3a = 2; mp3b = 2
    elif nrw == 6:
        mp1a = 3; mp1b = 3
        mp2a = 2; mp2b = 2
        mp3a = 1; mp3b = 2
    elif nrw == 4 or nrw == 3 :
        mp1a = 3; mp1b = 3
        mp2a = 1; mp2b = 2
        mp3a = 1; mp3b = 2
    elif nrw == 2:
        mp1a = 2; mp1b = 3
        mp2a = 1; mp2b = 2
        mp3a = 1; mp3b = 2
    #-------------------------------#
    # Resnet model
    input_resnet = Input(shape=(ncl, 1),
                         dtype='float32',
                         name='inputs')
    # Resnet output needs to be a flattened layer
    output_resnet = CNNetR(input_resnet,nrw)#Varsha ed: Add argument nrw
    # Block 1
    inputA = Input(shape=(nrw, ncl, 1))
    outputA = Conv2D(filters=32, kernel_size=(3, 3), padding="same", activation='relu')(inputA)
    outputA = BatchNormalization(axis=2)(outputA)
    outputA = MaxPooling2D(pool_size=(mp1a, mp1b))(outputA)
    outputA = Dropout(0.2)(outputA)
    # Block 2
    outputA = Conv2D(filters=32, kernel_size=(3, 3), padding="same", activation='relu')(outputA)
    outputA = BatchNormalization(axis=2)(outputA)
    outputA = Conv2D(filters=32, kernel_size=(3, 3), padding="same", activation='relu')(outputA)
    outputA = BatchNormalization(axis=2)(outputA)
    outputA = MaxPooling2D(pool_size=(mp2a, mp2b))(outputA)
    outputA = Dropout(0.2)(outputA)
    # Block 3
    outputA = Conv2D(filters=32, kernel_size=(3, 3), padding="same", activation='relu')(outputA)
    outputA = BatchNormalization(axis=2)(outputA)
    outputA = Conv2D(filters=32, kernel_size=(3, 3), padding="same", activation='relu')(outputA)
    outputA = BatchNormalization(axis=2)(outputA)
    outputA = MaxPooling2D(pool_size=(mp3a, mp3b))(outputA)
    outputA = Dropout(0.5)(outputA)

    outputA = Flatten()(outputA)
    ext_feat = Input(shape=(14,))
    # concat_feat = concatenate([outputA, ext_feat],axis=1)
    concat_feat = concatenate([outputA, output_resnet, ext_feat])

    output = Dense(num_classes, activation='sigmoid')(concat_feat)

    model = Model([inputA, input_resnet, ext_feat], [output])

    return model